/*
 * Nomad Instrument Control Software
 *
 * Copyright 2011 Institut Laue-Langevin
 *
 * Licensed under the EUPL, Version 1.1 only (the "License");
 * You may not use this work except in compliance with the Licence.
 * You may obtain a copy of the Licence at:
 *
 * http://joinup.ec.europa.eu/software/page/eupl
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the Licence is distributed on an "AS IS" basis,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the Licence for the specific language governing permissions and
 * limitations under the Licence.
 */

#ifndef CFDDEF_H
#define CFDDEF_H

namespace cfd {

static const int32 MAX_CHANNELS = 16;

// A32 base adress initialisaton : 0x1000000.
static const uint32 A24_ROTARY_SWITCHES_REGISTER = 0x400;
static const uint32 ENABLE_VME_SLAVE_REGISTER = 0x408;
static const uint32 A32_INIT_BA_REGISTER = 0x560;
static const uint32 ENABLE_A32_BA_REGISTER = 0x5F8;
static const uint32 MMU_PAGE_ZERO_REGISTER = 0x410;
static const uint32 DESCRIPTOR_FOR_SUSER_REGISTER = 0x414;
// Values.
static const uint32 ENABLE_VME_SLAVE = 0x80000010;
static const uint32 A32_INIT_BA = 0x01;
static const uint32 ENABLE_A32_BA = 0x10;
static const uint32 MMU_PAGE_ZERO = 0x0;
static const uint32 DESCRIPTOR_FOR_SUSER = 0x4803;
static const uint32 DESCRIPTOR_FOR_SUSER_2 = 0x2C03;
// Direction for the P2 lines.
static const uint32 ENABLE_PLL_CLOCK_REGISTER = 0x1090;
static const uint32 ENABLE_SERDES_VMEP2_REGISTER = 0x1090;
// Values.
static const uint32 ENABLE_PLL_CLOCK = 0x1;
static const uint32 ENABLE_SERDES_VMEP2 = 0xC3;

// Command
static const int32 ADC_RESET_COMMAND_REG = 0x10E8;
static const int32 WRITE_PARAM_COMMAND_REG = 0x1010;
static const int32 START_COMMAND_REG = 0x1000;
static const int32 STOP_COMMAND_REG = 0x1004;
static const int32 RESET_COMMAND_REG = 0x1014;
static const int32 WRITE_DUMMY_COMMAND_REG = 0x1018;

static const int32 GLOBAL_PARAMETER = 0x1000;

static const int32 BUFFER_STATUS_REG = 0x1390;
static const int32 BUFFER_0_READY = 1 << 16;
static const int32 BUFFER_1_READY = 1 << 17;
static const int32 BUFFERS_READY = BUFFER_0_READY + BUFFER_1_READY;

static const int32 BUFFER_0_SIZE = 0x1394;
static const int32 BUFFER_1_SIZE = 0x1398;

static const int32 BUFFER_0_REG = 0x100000;

static const int32 CURVES_REG = 0x0;
static const int32 CURVES_READY = 1;

static const int32 DATA_REG = 0x0;

}

#endif //CFDDEF_H
